// Source file: ../../sourcen/shell/io/AbortInputServlet.java

//package io;

import systemcontrol.Flowcontrol;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.net.*;
import io.StartConcept;
import io.ComboBoxElement;
import io.TextBoxElement;
import io.CheckBoxElement;
import io.Element;
import knowledge.T_Box;
import knowledge.A_Box;
import exceptions.*;
import operators.OperatorDB;

/**
   @author Niels Schroeter
 */



public class AbortServlet extends HttpServlet {
  long id;
    
    /**
       @roseuid 37A975D5B900
     */
  public void init(ServletConfig config) {
    }
    
    /**
       @roseuid 37A975F14148
     */
  public void doGet(HttpServletRequest req, HttpServletResponse res) 
      throws ServletException, IOException {
      
      PrintWriter  out;
      
      out = res.getWriter();  
      // set content type and other response header fields first
      res.setContentType("text/html");

      String servletfullpath=req.getServletPath();
      String servletpath=  (servletfullpath.substring(0,servletfullpath.lastIndexOf("/")));

      Enumeration enum = req.getParameterNames();
      while (enum.hasMoreElements())
	{
	  String values[];
	  String name = (String) enum.nextElement();
	  values = req.getParameterValues(name);
	if (values != null)
	  {
	    for (int i=0; i<values.length; i++)
	      {		 
		if (name.equals("SearchID"))
		  {
		    String sid = values[i];
		    id = Long.parseLong(sid);	   
		  }
	      }
	  }
      }

      Flowcontrol.getMainTable().removeMainElement(id);
      
      // then write the data of the response
      out.println("<HTML><HEAD><TITLE></TITLE><BODY>");
      
      out.println("ABORTED! AGENT STOPPED...");
      out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/agent\">");
      out.println("<INPUT TYPE=SUBMIT VALUE=NEWSEARCH></form>");
          
      out.println("</BODY></HTML>");
      
      out.close();  
  }
    
    /**
       @roseuid 37A976199978
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
    }
}

