// Source file: ../../sourcen/shell/io/OutputmaskServlet.java

//package io;
import io.StartConcept;
import io.Output;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import systemcontrol.ResultsList;
import systemcontrol.Results;
import systemcontrol.Reference_table;
import systemcontrol.Flowcontrol;
import systemcontrol.PlanObject;
import knowledge.A_Box;
import knowledge.T_Box;
import exceptions.*;
/**
   @author niels schroeter

 */
public class OutputmaskServlet extends HttpServlet{
    long id;
    int reload;
    /**
       @roseuid 37A8373FE4B8
     */
    public void init(ServletConfig config) {
    }
  

  /**
    @roseuid 37A837685CB0
    */
  public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
    PrintWriter		out;
    String servletfullpath=req.getServletPath();
    String servletpath=  (servletfullpath.substring(0,servletfullpath.lastIndexOf("/")));

    Enumeration enum = req.getParameterNames();
    while (enum.hasMoreElements())
      {  
	String values[]; 
	String name = (String) enum.nextElement();
	values = req.getParameterValues(name);
	if (values != null)
	  {
	    for (int i=0; i<values.length; i++)
	      {		
		if (name.equals("SearchID"))
		  {
		    String sid = values[i];
		    id = Long.parseLong(sid);	   
		  }
		if (name.equals("reload"))
		  {
		    String sreload = values[i];
		    reload = Integer.parseInt(sreload);	   
		  }	
	      }
	  }
      }
    
    if ((Flowcontrol.getMainTable()).getMainElement(id)!=null)
      {
    
	Flowcontrol flow=((Flowcontrol.getMainTable()).getMainElement(id)).getFlowcontrol();      
	ResultsList results = ((Flowcontrol.getMainTable()).getMainElement(id)).getResultsList();
	Output output = ((Flowcontrol.getMainTable()).getMainElement(id)).getOutput();
	Reference_table rt = ((Flowcontrol.getMainTable()).getMainElement(id)).getReference_table(); 

	// Zwei Fenster wurden geoeffnet
	if(reload==0) {

	  while(!output.searchEnd(rt))
	    {
	    }

	  LinkedList Reference = rt.getReferenceObject();
	  for (int i=0; i<Reference.size(); i++) {
	    PlanObject PO = (PlanObject)Reference.get(i);
	    Results resu = PO.getPlanInfo().getResults();
	    results.eliminateEqualUrl();
	    results.sort(); 
	  }
      
	  res.setContentType("text/html");
	  out = res.getWriter();
	  out.println("<HTML><body>");
	  out.println("Endergebnis:<br>");
	  try{
	    String outputMask = output.generateOutputMask(results);
	    out.println(outputMask);
	    out.println("Die Suche ist beendet.");
	    out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/agent\">");
	    out.println("<INPUT TYPE=SUBMIT VALUE=NEWSEARCH></form>");
	    out.close();
	    flow.endSearch();
	  }
	  catch (NetResultReloadFailedException e) {out.println("<b>NetResultReloadFailedException: ");}
	}
	// Nur ein Fenster
	else {
	  LinkedList Reference = rt.getReferenceObject();
	  for (int i=0; i<Reference.size(); i++) {
	    PlanObject PO = (PlanObject)Reference.get(i);
	    Results resu = PO.getPlanInfo().getResults(); 
	    results.add(resu);
	    results.eliminateEqualUrl();
	    results.sort();
	  }
	  res.setContentType("text/html");
	  out = res.getWriter();
	  //Letzter Aufruf, Suche ist beendet
	  if(output.searchEnd(rt))
	    {

	      out.println("<HTML><HEAD>");
	      out.println("</head><body>");
	      out.println("<br>Endergebnis:");
	      try {
		String outputMask = output.generateOutputMask(results);
		out.println(outputMask);
	      }
	      catch (NetResultReloadFailedException e) {out.println("<b>NetResultReloadFailedException: ");}


	      flow.endSearch();
	      out.println("Die Suche ist beendet.");
	      out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/agent\">");
	      out.println("<INPUT TYPE=SUBMIT VALUE=NEWSEARCH></form>");	    }
	  //Die Suche laeuft weiter
	  else {
	    out.println("<HTML><HEAD><meta http-equiv=\"refresh\" content=\""+reload+"; "
			+"URL="+servletpath+"/OutputmaskServlet?SearchID="+id+"&reload="+reload+"\">");
	    out.println("</head><body>");
	    out.println("SearchId = "+id);
	    out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/AbortServlet\">");
	    out.println("<INPUT TYPE=hidden name=\"SearchID\" value="+id+">");
	    out.println("<INPUT TYPE=SUBMIT VALUE=ABORT>");
	    out.println("<br>Zwischenergebnis, die Suche l&auml;uft weiter...");
	    try {
	      String outputMask = output.generateOutputMask(results);
	      out.println(outputMask);
	    }
	    catch (NetResultReloadFailedException e) {out.println("<b>NetResultReloadFailedException: ");}
	  }
	  out.println("</body></HTML>");
	  out.close();
	}
      }
    else {
      res.setContentType("text/html");
      out = res.getWriter();
      out.println("<HTML><body>");
      out.println("ERROR: SearchID non-existent or Search expired...");
      out.close();
      }
  }
  
  /**
       @roseuid 37A838333DE0
  */
  
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
    }
}
