// Source file: ../../sourcen/shell/io/PartialResultsServlet.java

//package io;

import systemcontrol.Flowcontrol;
import systemcontrol.Reference_table;
import systemcontrol.PlanObject;
import java.io.*;
//import java.lang.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import systemcontrol.ResultsList;
import systemcontrol.Flowcontrol;
import io.Output;
import exceptions.*;
import informationexchange.LogService;
import systemcontrol.Results;

/**
   @author niels schroeter

 */
public class PartialResultsServlet extends HttpServlet{
  long id;
    
    /**
       @roseuid 37A83A85F250
     */
    public void init(ServletConfig config) {
    }
    
    /**
       @roseuid 37A83AA21F48
     */
    public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
      //HttpSession session = req.getSession(true);
    PrintWriter		out;
    res.setContentType("text/html");
      String servletfullpath=req.getServletPath();
      String servletpath=  (servletfullpath.substring(0,servletfullpath.lastIndexOf("/")));
      LogService.log(0,this,"analysiere parameter...");

      Enumeration enum = req.getParameterNames();
      while (enum.hasMoreElements())
	{
	  String values[];
	  String name = (String) enum.nextElement();
	  values = req.getParameterValues(name);
	if (values != null)
	  {
	    for (int i=0; i<values.length; i++)
	      {		 
		if (name.equals("SearchID"))
		  {
		    String sid = values[i];
		    id = Long.parseLong(sid);	   
		  }
	      }
	  }
      }
      
      if ((Flowcontrol.getMainTable()).getMainElement(id)!=null)
	{
    ResultsList results = ((Flowcontrol.getMainTable()).getMainElement(id)).getResultsList();
    Output output = ((Flowcontrol.getMainTable()).getMainElement(id)).getOutput();
    Flowcontrol flow = ((Flowcontrol.getMainTable()).getMainElement(id)).getFlowcontrol();
    Reference_table rt = flow.rt;
    LinkedList Reference = rt.getReferenceObject();
    for (int i=0; i<Reference.size(); i++) {
      PlanObject PO = (PlanObject)Reference.get(i);
      Results resu = PO.getPlanInfo().getResults(); 
      results.add(resu);
      results.eliminateEqualUrl();
      results.sort();
    }
    out = res.getWriter();
    out.println("<html><body>");
    out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/PartialResultsServlet\">");
    out.println("<INPUT TYPE=hidden name=\"SearchID\" value="+id+">");
    out.println("<INPUT TYPE=SUBMIT VALUE=ZWISCHENERGEBNISSE></form>");
    out.println("<INPUT TYPE=hidden name=\"SearchID\" value="+id+">");
    out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/AbortServlet?SearchID="+id+"\">");
    out.println("<INPUT TYPE=SUBMIT VALUE=ABORT>");
    //out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/InputmaskServlet\">");
    //out.println("<INPUT TYPE=SUBMIT VALUE=NEWSEARCH>");
    
    out.println("<br>Zwischenergebnis");
    try {
      String outputMask = output.generateOutputMask(results);
      out.println(outputMask);
    }
    catch (NetResultReloadFailedException e) {out.println("<b>NetResultReloadFailedException: ");}
    out.println("</HTML>");
    out.close();
	}
      else
	{
	  res.setContentType("text/html");
	  out = res.getWriter();
	  out.println("<HTML><body>");
	  out.println("ERROR: SearchID non-existent or Search expired...");
	  out.close();
	}
  
    // NUR ZU DEBUG ZWECKEN !!!!!!!!!
    //flow.endSearch();
    
    }
    
    /**
       @roseuid 37A83AE2FA10
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
    }
}
