package operators;
import operators.PredArgument;

/**
   GuessCompageComOperator. GuessCompageOperator mit der geratenen URL   
   www.companyname.com
   @author Christian Fischbach
   @version 1.0
*/
public class GuessCompageComOperator extends GuessCompageOperator {


    protected String guessURL() {
        String guessedURL = "http://www.";
        PredArgument companynamePA = this.precond[0].getPredArg(0);
        guessedURL += companynamePA.getInstance().name; 
        guessedURL += ".com";
        return guessedURL;
    }//guessedURL

}//GuessCompageComOperator
