package operators;
import operators.PredArgument;

/**
   GuessCompageDeOperator. GuessCompageOperator mit der geratenen URL   
   www.companyname.de
   @author Christian Fischbach
   @version 1.0
*/

public class GuessCompageDeOperator extends GuessCompageOperator {

    protected String guessURL() {
        String guessedURL = "http://www.";
        PredArgument companynamePA = this.precond[0].getPredArg(0);
        guessedURL += companynamePA.getInstance().name; 
        guessedURL += ".de";
        return guessedURL;
    }//guessURL

}//class GuessCompageDeOperator





