package operators;
import operators.PredArgument;

/**
   GuessCompageMinusComDeOperator. GuessCompageOperator mit der geratenen URL   
   www.companyname-com.de
   @author Christian Fischbach
   @version 1.0
*/
public class GuessCompageMinusComDeOperator extends GuessCompageOperator {

    protected String guessURL() {
        String guessedURL = "http://www.";
        PredArgument companynamePA = this.precond[0].getPredArg(0);
        guessedURL += companynamePA.getInstance().name; 
        guessedURL += "-com.de";
        return guessedURL;
    }//guessedURL

}//class GuessCompageMinusComDeOperator
