/// Source file: ../../sourcen/shell/systemcontrol/MainElement.java

package systemcontrol;

import java.util.EventListener;
import systemcontrol.event.*;
import knowledge.PlanArchive;
import io.*;
import informationexchange.LogService;

/**
   Die Tabelle enthaelt eine Liste. Ein Listenelement enthaelt alle, 
   fuer eine Suche benoetigten Objekte.
*/
public class MainElement {

  Object EventListener;
  ResultsList results;
  public PlanArchive planArchive;  
  SearchID sid;
  Reference_table rt;
  Input input;
  Output output;
  StartConcept start;
  Flowcontrol flow;
  boolean destroy = false;
  int endDate = 0;

  public MainElement(Object EventListener, ResultsList results, 
		     PlanArchive planArchive, SearchID sid, Reference_table rt,
		     Input input, Output output, StartConcept start, Flowcontrol flow) {
    this.EventListener = EventListener;
    this.results = results;  
    this.planArchive = planArchive;      
    this.sid = sid;
    this.rt = rt;
    this.input = input;
    this.output = output;
    this.start = start;
    this.flow = flow;
  }

  public void setMainElement(SearchID id) {
  }

  public SearchID getSearchID() {
    return sid;
  }

  public Object getEventListener() {
    return EventListener;
  }

  public ResultsList getResultsList() {
    return results;
  }

  public PlanArchive getPlanArchive() {
    return planArchive;
  }

  public Reference_table getReference_table() {
    return rt;
  }
  
  public Input getInput() {
    return input;
  }

  public Output getOutput() {
    return output;
  }

  public StartConcept getStartConcept() {
    LogService.log(100,this,"StartConzept  "+sid.getSearchID());
    return start;
  }

  public Flowcontrol getFlowcontrol() {
    LogService.log(100,this,"Flowcontrol  "+sid.getSearchID());
   return flow;
  }
  public void setDestroy(boolean destroy) {
    this.destroy = destroy;
  }
  public boolean getDestroy() {
    return destroy;
  }
   
  public void setEndDate(int hour) {
    endDate = hour;
  }

  public int getEndDate() {
    return endDate;
  }
  /** 
      Gibt eine lokale A-Box aus
  */
  /*
  public A_Box getA_Box(PlanID) {
    A_Box abox = rt.getReferenceObjekt()
    return abox;
  }

  public T_Box getT_Box() {
    return tbox;
  }

  */

}
